{ Copyright (c) 2000 by Mandys Tomas - Mandy Soft }
{ email: tomas.mandys@2p.cz }
{ URL: http://www.2p.cz }

unit Dbbrowfr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, DBGrids, DB, DBTables, ExtCtrls,
  DBCtrls, Menus, Buttons;

type
  TDBBrowserForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DataSource1: TDataSource;
    DBGrid: TDBGrid;
    IndexComboBox: TComboBox;
    Edit1: TEdit;
    DBNavigator1: TDBNavigator;
    PopupMenu1: TPopupMenu;
    Search1: TMenuItem;
    N2: TMenuItem;
    Opentable1: TMenuItem;
    OpenDialog: TOpenDialog;
    Newtable1: TMenuItem;
    FindDialog: TFindDialog;
    RecNo: TEdit;
    N1: TMenuItem;
    RecNumber: TMenuItem;
    Deleted: TMenuItem;
    Undelete: TMenuItem;
    Memoonoff1: TMenuItem;
    FieldsSubMenu: TMenuItem;
    N3: TMenuItem;
    About1: TMenuItem;
    DBMemo1: TDBMemo;
    Splitter1: TSplitter;
    Countfield1: TMenuItem;
    Fillfieldinrecords1: TMenuItem;
    Table_For_MyLibs: TTable;
    BooleanField1: TBooleanField;
    IntegerField1: TIntegerField;
    N4: TMenuItem;
    Newtable2: TMenuItem;
    Opentable2: TMenuItem;
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure TableAfterOpen(DataSet: TDataset);
    procedure IndexComboBoxChange(Sender: TObject);
    procedure Search2Click(Sender: TObject);
    procedure Opentable1Click(Sender: TObject);
    procedure TableBeforeOpen(DataSet: TDataset);
    procedure TableAfterClose(DataSet: TDataset);
    procedure FindDialogFind(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure TableCalcFields(DataSet: TDataset);
    procedure RecNumberClick(Sender: TObject);
    procedure DeletedClick(Sender: TObject);
    procedure UndeleteClick(Sender: TObject);
    procedure Memoonoff1Click(Sender: TObject);
    procedure DBGridColEnter(Sender: TObject);
    procedure FieldsSubMenuClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Countfield1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Fillfieldinrecords1Click(Sender: TObject);
  private
    Table: TTable;
    StopFlag: Boolean;
    Found: Boolean;
    FindFlag: Byte;
    procedure SetRO(aRO: Boolean);
  public
  end;

  TTable2 = class(TTable)
  protected
    procedure CreateFields; override;
  end;

var
  DBBrowserForm: TDBBrowserForm;

var
  DatabaseNameParam, TableNameParam: string;
  ReadOnlyParam: Boolean;

resourcestring
  sInput = 'Input';
  scfMask = 'Counting mask (Format procedure mask with one %d parameter)';
  scfStart = 'Start number';
  scfInc = 'Increment';
  scfCount = 'Count (-1..infinity)';
  sfrString = 'String';
implementation
uses
  AuxStr, dbiProcs, dbiTypes, DBUtils, dbiErrs, SelTable;

{$R *.DFM}

const
  RecNoFld = '_REC_NO_';
  DelFld = '_DELETED_';

procedure TTable2.CreateFields;
var
  F: TField;
begin
  inherited;
  F := TIntegerField.Create(Self);
  F.FieldName := RecNoFld;
  F.DisplayLabel:= '#Rec';
  F.FieldKind:= fkCalculated;
//  Fields.Add(F);
  F.DataSet:= Self;
  F.Index := 0;
  F.Visible:= False;

  F := TBooleanField.Create(Self);
  F.FieldName := DelFld;
  F.DisplayLabel:= 'D';
  F.FieldKind:= fkCalculated;
  (F as TBooleanField).DisplayValues:= '*; ';
//  Fields.Add(F);
  F.DataSet:= Self;
  F.Index := 0;
  F.Visible:= False;
end;

procedure TDBBrowserForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Return) and (Shift = []) then
  begin
    if (Edit1.Text <> '') and (Table.IndexName <> '') then
    begin
      Table.FindNearest([Edit1.Text]);
      Key:= 0;
    end;
  end;
end;

procedure TDBBrowserForm.FormCreate(Sender: TObject);
begin
  Table:= TTable2.Create(Self);
  Table.BeforeOpen:= TableBeforeOpen;
  Table.AfterOpen:= TableAfterOpen;
  Table.AfterClose:= TableAfterClose;
  Table.OnCalcFields:= TableCalcFields;

  DataSource1.DataSet:= Table;
  try
    GetAliasPath(DatabaseNameParam);
    Table.DatabaseName:= DatabaseNameParam;
  except
  end;
  Table.TableName:= TableNameParam;
  Table.ReadOnly:= ReadOnlyParam;
  if TableNameParam <> '' then
    Table.Open;
  if DatabaseNameParam <> '' then
    OpenDialog.InitialDir:= GetAliasPath(DatabaseNameParam);
//  AboutBoxDlg1.Comments:= 'Using IDAPI 16-bit'#13#13'Comments, bugs and ideas send to tma@email.cz';
end;

procedure TDBBrowserForm.TableAfterOpen(DataSet: TDataset);
const
  But= [nbEdit, nbPost, nbCancel];
  MaxWidth = 35;
var
  I: Integer;
  MI: TMenuItem;
begin
  if Table.ReadOnly then DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons-But
                    else DBNavigator1.VisibleButtons:= DBNavigator1.VisibleButtons+But;
  DBNavigator1.Width:= 10; { adjust width }
  for I:= 0 to Table.FieldCount-1 do
    if Table.Fields[I].DisplayWidth > MaxWidth then
      Table.Fields[I].DisplayWidth:= MaxWidth;
  while FieldsSubMenu.Count > 0 do
    FieldsSubMenu.Delete(0);
  for I:= 2 to Table.FieldCount-1 do
  begin
    MI:= TMenuItem.Create(Self);
    MI.Caption:= Table.Fields[I].FieldName;
    MI.Checked:= Table.Fields[I].Visible;
    MI.OnClick:= FieldsSubMenuClick;
    FieldsSubMenu.Add(MI);
  end;
  IndexComboBox.Items.Clear;
  Table.GetIndexNames(IndexComboBox.Items);
  IndexComboBox.Items.Insert(0, '<no index>');
  IndexComboBox.ItemIndex:= 0;
  TableAfterClose(DataSet);
  Deleted.Enabled:= dbiSetDelete(Table, Table.FieldByName(DelFld).Visible) = DBIERR_NONE;
  DBGridColEnter(nil);
end;

procedure TDBBrowserForm.IndexComboBoxChange(Sender: TObject);
begin
  with IndexComboBox do
    if Text[1] = '<' then Table.IndexName:= ''
                     else Table.IndexName:= Text;
end;

procedure TDBBrowserForm.Search2Click(Sender: TObject);
begin
  Found:= False;
  FindDialog.Execute;
end;

procedure TDBBrowserForm.Opentable1Click(Sender: TObject);
var
  S: string;
  RO: Boolean;
begin
  if (Sender as TComponent).Tag and $02 <> 0 then
    begin
      with TSelectTable.Create(nil) do
      try
        Alias.ItemIndex:= Alias.Items.IndexOf(DatabaseNameParam);
        if ShowModal <> mrOk then
          Exit;
        TableNameParam := Tables.Items[Tables.ItemIndex];
        DatabaseNameParam:= Alias.Text;
        RO:= ReadOnly.Checked;
      finally
        Free;
      end;
    end
  else
    begin
      if not OpenDialog.Execute then
        Exit;
      DatabaseNameParam:= '';
      TableNameParam:= OpenDialog.Filename;
      RO:= ofReadOnly in OpenDialog.Options;
    end;
  if (Sender as TComponent).Tag and $01 <> 0 then
    begin
{          with TDBBrowserForm.Create(nil) do
        Show; }
      S:= ParamStr(0) + ' '+TableNameParam;
      if DatabaseNameParam <> '' then
        S:= S+' /A:'+DatabaseNameParam;
      if RO then
        S:= S+' /RO';
      S:= S+#0;
      WinExec(@S[1], SW_SHOW);
    end
  else
    begin
      Table.Close;
      Table.DatabaseName:= DatabaseNameParam;
      Table.TableName := TableNameParam;
      Table.IndexName:= '';
      Table.ReadOnly:= RO;
      Table.Open;
    end;
end;

procedure TDBBrowserForm.TableBeforeOpen(DataSet: TDataset);
var
  S: string;
begin
  if Pos(':', Table.TableName) = 0 then
    S:= UpString(GetAliasPath(Table.DatabaseName))
  else
    S:= '';
  Caption:= Format('DB Browser [%s%s]', [S, Table.TableName]);
end;

procedure TDBBrowserForm.TableAfterClose(DataSet: TDataset);
begin
  FieldsSubMenu.Enabled:= DataSet.Active;
  Search1.Enabled:= DataSet.Active;
  RecNumber.Enabled:= DataSet.Active;
  Deleted.Enabled:= DataSet.Active;
  Undelete.Enabled:= DataSet.Active;
  DBMemo1.DataField:= '';
end;

procedure TDBBrowserForm.FindDialogFind(Sender: TObject);
var
  S, S2: string;
  F, F1, F2: Boolean;
  DownS: Boolean;
  function UpC(const S: string): string;
  begin
    Result:= S;
    if not (frMatchCase in FindDialog.Options) then
      Result:= DBAnsiUpper(Table, Result);
  end;
  procedure Mov;
  begin
    if DownS then Table.Next
             else Table.Prior;
  end;
begin
  if FindFlag <> 0 then
  begin
    StopFlag:= True;
    Exit;
  end;
  StopFlag:= False;
  Inc(FindFlag);
  try
    S:= Trim(UpC(FindDialog.FindText));
    DownS:= frDown in FindDialog.Options;

    if (Length(S) > 1) and (S[1] = '"') and (S[Length(S)] = '"') then
    begin
      Delete(S, 1, 1);
      Delete(S, Length(S), 1);
      F1:= False;
      F2:= False;
    end
  else
    begin
      F1:= S[1] = '*';
      if F1 then Delete(S, 1, 1);
      F2:= S[Length(S)] = '*';
      if F2 then Delete(S, Length(S), 1);
    end;
    if Found then
      Mov;
    repeat
      S2:= UpC(DBGrid.SelectedField.AsString);
      Application.ProcessMessages;
      if not F1 and not F2 then F:= S = S2 else
      if F1 and F2 then F:= Pos(S, S2) > 0 else
      if F2 then F:= S = Copy(S2, 1, Length(S)) else
      if F1 then F:= S = RStr(S2, Length(S));
      Found:= F;
      if F or StopFlag or (DownS and Table.EOF) or (not DownS and Table.BOF) then Break;
      Mov;
    until False;
  finally
    Dec(FindFlag);
  end;
end;

procedure TDBBrowserForm.DataSource1DataChange(Sender: TObject;
  Field: TField);
begin
  if Table.Active then
  begin
//    RecNo.Text:= Format('%d/%d', [Table.FieldByName(RecNoFld).AsInteger, _GetRecordCount(Table)]); 
  end
else
  RecNo.Text:= '';
end;

procedure TDBBrowserForm.TableCalcFields(DataSet: TDataset);
var
  L: Longint;
  RP: RecProps;
begin
  if dbiGetSeqNo(Table.Handle, L) <> 0 then
  begin
    dbiGetRecord(Table.Handle, dbiNoLock , nil, @RP);
    L:= RP.iPhyRecNum;
  end;
  Table.FieldByName(RecNoFld).AsInteger:= L;
  DbiGetRecord(Table.Handle, dbiNoLock, Nil, @RP);
  Table.FieldByName(DelFld).AsBoolean:= RP.bDeleteFlag;
end;

procedure TDBBrowserForm.RecNumberClick(Sender: TObject);
begin
  Table.FieldByName(RecNoFld).Visible:= not Table.FieldByName(RecNoFld).Visible;
end;

procedure TDBBrowserForm.DeletedClick(Sender: TObject);
begin
  Table.FieldByName(DelFld).Visible:= not Table.FieldByName(DelFld).Visible;
  dbiSetDelete(Table, Table.FieldByName(DelFld).Visible);
end;

procedure TDBBrowserForm.UndeleteClick(Sender: TObject);
var
  rslt: DBIResult;
  szErrMsg: DBIMSG;
begin
  if (Table.State = dsBrowse) and not Table.FieldByName(DelFld).IsNull then
  begin
    Table.UpdateCursorPos;
    rslt:= dbiUndeleteRecord(Table.Handle);
    Table.Resync([]);
    if rslt <> DBIERR_NONE then
    begin
       DbiGetErrorString(rslt, szErrMsg);
       raise Exception.Create(StrPas(szErrMsg));
    end;
  end;
end;

procedure TDBBrowserForm.Memoonoff1Click(Sender: TObject);
begin
  DBMemo1.Visible:= not DBMemo1.Visible;
  DBMemo1.AutoDisplay:= DBMemo1.Visible;
end;

procedure TDBBrowserForm.DBGridColEnter(Sender: TObject);
begin
  if DBGrid.SelectedField = nil then DBMemo1.DataField:= '' 
                                else DBMemo1.DataField:= DBGrid.SelectedField.FieldName;
end;

procedure TDBBrowserForm.FieldsSubMenuClick(Sender: TObject);
begin
  with Sender as TMenuItem do
  begin
    Checked:= not Checked;
    Table.FieldByName(Caption).Visible:= Checked;
  end;
end;

procedure TDBBrowserForm.About1Click(Sender: TObject);
begin
//  AboutBoxDlg1.Execute;
end;


procedure TDBBrowserForm.Countfield1Click(Sender: TObject);
var
  aStart, aInc, aCount: Integer;
  S, aMask: string;
begin
  aMask:= '%d';
  if not InputQuery(sInput, scfMask, aMask) then
    Exit;
  S:= '1';
  if not InputQuery(sInput, scfStart, S) then
    Exit;
  aStart:= StrToInt(S);
  S:= '1';
  if not InputQuery(sInput, scfInc, S) then
    Exit;
  aInc:= StrToInt(S);
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

    StopFlag:= False;
    while not Table.EOF and not StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= Format(aMask, [aStart]);
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
      Inc(aStart, aInc);
    end;
end;

procedure TDBBrowserForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Escape) and (Shift = []) then
    StopFlag:= True;
end;

procedure TDBBrowserForm.Fillfieldinrecords1Click(Sender: TObject);
var
  aCount: Integer;
  S, aString: string;
begin
  aString:= '';
  if not InputQuery(sInput, sfrString, aString) then
    Exit;
  S:= '0';
  if not InputQuery(sInput, scfCount, S) then
    Exit;
  aCount:= StrToInt(S);

  SetRO(True);
  try
    StopFlag:= False;
    while not Table.EOF and not StopFlag and (aCount <> 0) do
    begin
      Table.Edit;
      DBGrid.SelectedField.AsString:= aString;
      Table.CheckBrowseMode;
      Table.Next;
      Application.ProcessMessages;
      if aCount <> -1 then
        Dec(aCount);
    end;
  finally
    SetRO(False);
  end;
end;

procedure TDBBrowserForm.SetRO;
begin
  DBGrid.Enabled:= not aRO;
  DBMemo1.Enabled:= not aRO;
end;

end.

